package ueb073schwellwert;

import processing.core.*;


@SuppressWarnings("serial")
public class Ueb073Schwellwert extends PApplet {

	PImage img;
	int schwellwert;
	
	public void setup() {  
		  img = loadImage("sonnenblume.jpg");
		  size(img.width, img.height);

		  image(img, 0, 0);
		}


		// ----- draw() -------------------------------------------------
	public void draw() {
		  // nothing
		}


		// ----- updateImage() ------------------------------------------
	public void updateImage() {
		  loadPixels(); // used for accessing each pixel 
		  img.loadPixels();
		  
		  //Processing 1-D image array
		  for (int y = 0; y < height; y++) {
		    for (int x = 0; x < width; x++) {
		      int loc = x + y * width; // calc new position/pixel
		      
		      int pixelColor = img.pixels[loc]; // get one Pixel

		      if (pixelColor > color(schwellwert,schwellwert,schwellwert)) { // use schwellwert
		        pixels[loc] = color(255,255,255);  }
		      else {
		        pixels[loc] = color(0,0,0);
		      }
		    }
		  }
		    
		  updatePixels(); // update display
		}


		// ----- mouseMoved() -------------------------------------------
	public void mouseMoved() {
		  schwellwert = (int) (255.0 / width * mouseX);
		  updateImage();
		}
}
