/****************************************************************
* Modul:   TA.BA_MMT.HS1301 - Multimedia Technik (MMT)
* Subject: Processing - Uebung 7 - Schwellwert
* Author:  Felix Rohrer
* Desc:    Bild in ein Monochrom Bild wandeln
****************************************************************/

PImage img;
color schwellwert;

// ----- setup() ------------------------------------------------
void setup() {  
  img = loadImage("sonnenblume.jpg");
  size(img.width, img.height);

  image(img, 0, 0);
}


// ----- draw() -------------------------------------------------
void draw() {
  // nothing
}


// ----- updateImage() ------------------------------------------
void updateImage() {
  loadPixels(); // used for accessing each pixel 
  img.loadPixels();
  
  //Processing 1-D image array
  for (int y = 0; y < height; y++) {
    for (int x = 0; x < width; x++) {
      int loc = x + y * width; // calc new position/pixel
      
      color pixelColor = img.pixels[loc]; // get one Pixel

      if (pixelColor > color(schwellwert,schwellwert,schwellwert)) { // use schwellwert
        pixels[loc] = color(255,255,255);  }
      else {
        pixels[loc] = color(0,0,0);
      }
    }
  }
    
  updatePixels(); // update display
}


// ----- mouseMoved() -------------------------------------------
void mouseMoved() {
  schwellwert = (int) (255.0 / width * mouseX);
  updateImage();
}
